#pragma GCC optimize("O2")
#pragma GCC target("avx,avx2,fma")
#include <bits/stdc++.h>
#define FOR(i, a, b) for (int i = (a); i <= (b); i++)
#define FOD(i, a, b) for (int i = (a); i >= (b); i--)
#define REP(i, n) for (int i = 0; i < (n); i++)
#define ALL(x) (x).begin(), (x).end()
#define TIME  (1.0 * clock() / CLOCKS_PER_SEC)
#define file(name)  if (fopen(name".in", "r")) { freopen(name".in", "r", stdin); freopen(name".out", "w", stdout); }

using namespace std;

const int MAXN = 70005;
const int INF = 1e9 + 7;

int N, disLeaf[MAXN], disStart[MAXN], tin[MAXN], tout[MAXN], timer = 0;
vector <int> ke[MAXN];

void BFS(void) {
    FOR(i, 1, N) disLeaf[i] = INF;
    queue <int> q;
    FOR(i, 1, N) if (ke[i].size() == 1) {
        disLeaf[i] = 0;
        q.push(i);
    }
    while (q.size()) {
        int u = q.front(); q.pop();
        for (int v : ke[u]) if (disLeaf[v] > disLeaf[u] + 1) {
            disLeaf[v] = disLeaf[u] + 1;
            q.push(v);
        }
    }
}

void DFS(int u, int par = -1) {
    tin[u] = ++timer;
    for (int v : ke[u]) if (v != par) {
        disStart[v] = disStart[u] + 1;
        DFS(v, u);
    }
    tout[u] = timer;
}

struct BIT{
    private :
        int bit[405][2 * MAXN];
    public :
        void update(int b, int x, int val) {
            for (x++; x < 2 * MAXN; x += x&-x) bit[b][x] += val;
        }
        long long get(int b, int x) {
            long long ans = 0;
            for (x++; x; x -= x&-x) ans += bit[b][x];
            return ans;
        }
} mybit;

int nBlock = 205, key[MAXN], val[MAXN], end_bl[405], start_bl[405], bl[MAXN];
long long ans[MAXN], lazySum = 0, lazy[405];
void update(int b, int val);
long long Total_Sum();
void update(int l, int r, int val);

void dfs_calc(int u, int par = -1) {
    ans[u] = Total_Sum();
    for (int v : ke[u]) if (v != par) {
        update(tin[v], tout[v], +2);
        lazySum--;
        dfs_calc(v, u);
        lazySum++;
        update(tin[v], tout[v], -2);
    }
}

signed main(void) {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    file("starwars4");
    cin >> N;
    FOR(i, 2, N) {
        int u, v; cin >> u >> v;
        ke[u].emplace_back(v);
        ke[v].emplace_back(u);
    }

    BFS();
    DFS(1);
    //nBlock = 1;
    FOR(i, 1, N) {
        bl[tin[i]] = tin[i] / nBlock;
        end_bl[bl[tin[i]]] = max(end_bl[bl[tin[i]]], tin[i]);
        if (start_bl[bl[tin[i]]] == 0) start_bl[bl[tin[i]]] = tin[i];
        else start_bl[bl[tin[i]]] = min(start_bl[bl[tin[i]]], tin[i]);

        val[tin[i]] = 2 - int(ke[i].size());
        key[tin[i]] = disLeaf[i] - disStart[i] + MAXN;
    }
    FOR(i, bl[1], bl[N]) update(i, 1);
    dfs_calc(1);
    FOR(i, 1, N) {
        if (ke[i].size() == 1) ans[i] = 1;
        cout << ans[i] << '\n';
    }
    cerr << "Time elapsed: " << TIME << " s.\n";
    return (0 ^ 0);
}

void update(int b, int sign) {
    FOR(i, start_bl[b], end_bl[b]) 
        mybit.update(b, key[i], val[i] * sign);
}

void update(int l, int r, int diff) {
    if (bl[l] == bl[r]) {
        update(bl[l], -1);
        FOR(i, l, r) key[i] += diff;
        update(bl[l], 1);
        return;
    }
    // l -> ebl[l]
    update(bl[l], -1);
    FOR(i, l, end_bl[bl[l]]) key[i] += diff;
    update(bl[l], 1);

    // sbl[r] - > r;
    update(bl[r], -1);
    FOR(i, start_bl[bl[r]], r) key[i] += diff;
    update(bl[r], 1);

    //
    FOR(b, bl[l] + 1, bl[r] - 1) lazy[b] += diff;
}

long long Total_Sum() {
    long long ans = 0;
    FOR(b, bl[1], bl[N]) ans += mybit.get(b, MAXN - lazy[b] - lazySum);
    return ans;
}
